#include "changewidget.h"
#include <QDebug>

ChangeWidget::ChangeWidget(QWidget *parent) : QWidget(parent)
{


    mainLayout = new QGridLayout(this);
    questionName = new QLineEdit();
    variants = new QLineEdit();
    answers = new QLineEdit();
    lb1 = new QLabel("Вопрос:");
    lb2 = new QLabel("Варианты ответа:");
    lb3 = new QLabel("Правильные ответы:");
    mainLayout->addWidget(lb1,0,0);
    mainLayout->addWidget(questionName,1,0);
    mainLayout->addWidget(lb2,2,0);
    mainLayout->addWidget(variants,3,0);
    mainLayout->addWidget(lb3,4,0);
    mainLayout->addWidget(answers,5,0);
    submitBtn = new QPushButton();
    mainLayout->addWidget(submitBtn,6,0);




}

void ChangeWidget::setQuestion(QuestionEntity &p_qe,int p_test_id)
{
    question = p_qe;
    test_id = p_test_id;
    p_que_name = p_qe.getQuestion();
}

void ChangeWidget::paintWidget(bool bToChange)
{
    this->show();
    bType = bToChange;
    if(bToChange)
    {
        submitBtn->setText("Изменить");
        questionName->setText(question.getQuestion());
        QString answersString;
        QString variantsString;
        for(auto & var: question.getAnswers())
        {
            answersString += var + " ";
        }
        answersString.chop(1);
        for(auto & var: question.getVariants())
        {
            variantsString += var + "%";
        }
        variantsString.chop(1);
        variants->setText(variantsString);
        answers->setText(answersString);
        disconnect(submitBtn, SIGNAL(clicked()), this, SLOT(AddNewQuestion()));
        connect(submitBtn, SIGNAL(clicked()), this, SLOT(UpdateCurrQuestion()));
        connect(submitBtn, SIGNAL(clicked()), this, SLOT(hide()));
    }
    else
    {
        submitBtn->setText("Добавить");
        disconnect(submitBtn, SIGNAL(clicked()), this, SLOT(UpdateCurrQuestion()));
        connect(submitBtn, SIGNAL(clicked()), this, SLOT(AddNewQuestion()));
        connect(submitBtn, SIGNAL(clicked()), this, SLOT(hide()));

    }

}


void ChangeWidget::recieveDataBase(const QSqlDatabase &db)
{
    f_db = db;
}

void ChangeWidget::receiveQuestion(const QuestionEntity &qe)
{
    question = qe;
}

void ChangeWidget::AddNewQuestion()
{
    QString question_Name = questionName->text();
    QString _var = variants->text();
    QString _ans = answers->text();
   QSqlQueryModel *model = new QSqlQueryModel(this);
   model->setQuery(QSqlQuery("SELECT MAX(id) from test_questions;", f_db));
   int id = model->index(0,0).data().toInt() + 1;
    model->setQuery(QSqlQuery("INSERT INTO test_questions VALUES ("+ QString::number(id) + ",'" + question_Name + "','"
   + _var + "','" + _ans + "',"+QString::number(test_id) + ");" ));
    qDebug() << "INSERT INTO test_questions VALUES ("+ QString::number(id) + ",'" + question_Name + "','"
   + _var + "','" + _ans + "',"+QString::number(test_id) + ");" ;
    \
}

void ChangeWidget::UpdateCurrQuestion()
{
    QString question_Name = questionName->text();
    QString _var = variants->text();
    QString _ans = answers->text();
   QSqlQueryModel *model = new QSqlQueryModel(this);
   model->setQuery(QSqlQuery("SELECT id from test_questions WHERE question = '"+p_que_name+"';", f_db));
   int id = model->index(0,0).data().toInt();
    model->setQuery(QSqlQuery("UPDATE test_questions SET  question = '"+question_Name+"',variants = '"+_var+
                              "', answer = '" + _ans +"' WHERE id = " + QString::number(id) + ";" ));
    qDebug() << "UPDATE test_questions SET  question = '"+question_Name+"',variants = '"+_var+
                "', answer = '" + _ans +"' WHERE id = " + QString::number(id) + ";";
}


