#ifndef CHANGEWIDGET_H
#define CHANGEWIDGET_H

#include <QWidget>
#include <QLineEdit>
#include <QLabel>
#include <QPushButton>
#include <QSqlDatabase>
#include <question.h>
#include <QGridLayout>
#include <QLabel>
#include <QSqlQuery>
#include <QSqlQueryModel>

class ChangeWidget : public QWidget
{
    Q_OBJECT
public:
    explicit ChangeWidget(QWidget *parent = nullptr);
    void setQuestion(QuestionEntity &p_qe, int p_test_id);

signals:
    void AddQuestion();
    void UpdateQuestion();

public slots:
    void paintWidget(bool bToChange);
    void recieveDataBase(const QSqlDatabase &db);
    void receiveQuestion(const QuestionEntity &qe);
    void AddNewQuestion();
    void UpdateCurrQuestion();


private:
    QSqlDatabase f_db;
    QuestionEntity question;
    QGridLayout *mainLayout;
    QLineEdit *questionName;
    QLineEdit *variants;
    QLineEdit *answers;
    QLabel *lb1;
    QLabel *lb2;
    QLabel *lb3;
    QPushButton *submitBtn;
    QString p_que_name;
    bool bType;
    int test_id;

};

#endif // CHANGEWIDGET_H
